## focuswriter 1.8.6

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2021-2023 Graeme Gott <graeme@gottcode.org>
#
# SPDX-License-Identifier: GPL-3.0-or-later

cmake_minimum_required(VERSION 3.16)

# Configure project
project(focuswriter VERSION 1.8.6 LANGUAGES CXX)

set(project_copyright "2008-2024 Graeme Gott")

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

if (WIN32)
	set(Iconv_IS_BUILT_IN true)
endif()

find_package(Qt6 REQUIRED COMPONENTS Concurrent Core Gui LinguistTools Multimedia Network PrintSupport Widgets)
find_package(Iconv REQUIRED)
find_package(ZLIB REQUIRED)
include(GNUInstallDirs)

add_compile_definitions(
	QT_NO_KEYWORDS
	$<$<CONFIG:DEBUG>:QT_STRICT_ITERATORS>
	$<$<CONFIG:DEBUG>:QT_NO_NARROWING_CONVERSIONS_IN_CONNECT>
	$<$<CONFIG:DEBUG>:QT_DISABLE_DEPRECATED_BEFORE=0x060600>
)

# Version number
include(cmake/AddVersionCompileDefinition.cmake)
add_version_compile_definition(src/application.cpp VERSIONSTR)

# Create translations
file(GLOB translations_SRCS translations/*.ts)
qt6_add_translation(translations_QM ${translations_SRCS})

add_custom_target(update_translations
	COMMAND Qt6::lupdate -no-obsolete -locations none src -ts ${translations_SRCS}
	WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
	VERBATIM
)

# Create program
qt6_add_executable(focuswriter
	src/action_manager.cpp
	src/alert.cpp
	src/alert_layer.cpp
	src/application.cpp
	src/block_stats.cpp
	src/color_button.cpp
	src/deltas.cpp
	src/daily_progress.cpp
	src/daily_progress_dialog.cpp
	src/daily_progress_label.cpp
	src/document.cpp
	src/document_cache.cpp
	src/document_watcher.cpp
	src/document_writer.cpp
	src/find_dialog.cpp
	src/gzip.cpp
	src/image_button.cpp
	src/load_screen.cpp
	src/locale_dialog.cpp
	src/main.cpp
	src/paths.cpp
	src/preferences.cpp
	src/preferences_dialog.cpp
	src/scene_list.cpp
	src/scene_model.cpp
	src/session.cpp
	src/session_manager.cpp
	src/shortcut_edit.cpp
	src/smart_quotes.cpp
	src/sound.cpp
	src/stack.cpp
	src/stats.cpp
	src/symbols_dialog.cpp
	src/symbols_model.cpp
	src/text_codec.cpp
	src/theme.cpp
	src/theme_dialog.cpp
	src/theme_manager.cpp
	src/theme_renderer.cpp
	src/timer.cpp
	src/timer_display.cpp
	src/timer_manager.cpp
	src/utils.cpp
	src/window.cpp
	src/fileformats/docx_reader.cpp
	src/fileformats/docx_writer.cpp
	src/fileformats/format_manager.cpp
	src/fileformats/html_writer.cpp
	src/fileformats/odt_reader.cpp
	src/fileformats/odt_writer.cpp
	src/fileformats/rtf_reader.cpp
	src/fileformats/rtf_tokenizer.cpp
	src/fileformats/rtf_writer.cpp
	src/fileformats/txt_reader.cpp
	src/spelling/dictionary_dialog.cpp
	src/spelling/dictionary_manager.cpp
	src/spelling/highlighter.cpp
	src/spelling/spell_checker.cpp
	src/3rdparty/qtsingleapplication/qtsingleapplication.cpp
	src/3rdparty/qtsingleapplication/qtlocalpeer.cpp
	src/3rdparty/qtzip/qtzip.cpp
	resources/images/images.qrc
	${translations_QM}
)

target_include_directories(focuswriter PRIVATE
	src
	src/fileformats
	src/spelling
	src/3rdparty/qtsingleapplication
	src/3rdparty/qtzip
)

target_link_libraries(focuswriter PRIVATE
	Qt6::Concurrent
	Qt6::Core
	Qt6::Gui
	Qt6::Multimedia
	Qt6::Network
	Qt6::PrintSupport
	Qt6::Widgets
	Iconv::Iconv
	ZLIB::ZLIB
)

# Add spellchecking support
if(APPLE)
	target_sources(focuswriter PRIVATE
		src/spelling/dictionary_provider_nsspellchecker.mm
	)

	find_library(APPKIT AppKit)
	target_link_libraries(focuswriter PRIVATE ${APPKIT})
elseif(WIN32)
	target_compile_definitions(focuswriter PRIVATE HUNSPELL_STATIC)

	target_include_directories(focuswriter PRIVATE src/3rdparty/hunspell)

	target_sources(focuswriter PRIVATE
		src/spelling/dictionary_provider_hunspell.cpp
		src/spelling/dictionary_provider_voikko.cpp
		src/3rdparty/hunspell/affentry.cxx
		src/3rdparty/hunspell/affixmgr.cxx
		src/3rdparty/hunspell/csutil.cxx
		src/3rdparty/hunspell/filemgr.cxx
		src/3rdparty/hunspell/hashmgr.cxx
		src/3rdparty/hunspell/hunspell.cxx
		src/3rdparty/hunspell/hunzip.cxx
		src/3rdparty/hunspell/phonet.cxx
		src/3rdparty/hunspell/replist.cxx
		src/3rdparty/hunspell/suggestmgr.cxx
	)
else()
	find_package(PkgConfig REQUIRED)
	pkg_check_modules(Hunspell REQUIRED IMPORTED_TARGET hunspell)

	target_sources(focuswriter PRIVATE
		src/spelling/dictionary_provider_hunspell.cpp
		src/spelling/dictionary_provider_voikko.cpp
	)

	target_link_libraries(focuswriter PRIVATE PkgConfig::Hunspell)
endif()

# Optimize build
option(ENABLE_LINK_TIME_OPTIMIZATION "Enable link time optimization" OFF)
if(ENABLE_LINK_TIME_OPTIMIZATION)
	include(CheckIPOSupported)
	check_ipo_supported(RESULT result)
	if(result)
		set_target_properties(focuswriter PROPERTIES INTERPROCEDURAL_OPTIMIZATION TRUE)
	endif()
endif()

option(ENABLE_STRIP "Enable automatic stripping of builds" OFF)
if(ENABLE_STRIP)
	add_custom_command(TARGET focuswriter
		POST_BUILD
		COMMAND ${CMAKE_STRIP} $<TARGET_FILE:focuswriter>
	)
endif()

# Create symbols
add_subdirectory(resources/symbols)

# Install
if(APPLE)
	set(datadir "../Resources")

	set_target_properties(focuswriter PROPERTIES
		OUTPUT_NAME FocusWriter
		MACOSX_BUNDLE TRUE
		MACOSX_BUNDLE_INFO_PLIST ${CMAKE_SOURCE_DIR}/resources/mac/Info.plist.in
	)

	include(cmake/BundleResources.cmake)
	bundle_data(focuswriter ${CMAKE_SOURCE_DIR}/resources/mac/focuswriter.icns Resources)
	bundle_data(focuswriter ${CMAKE_SOURCE_DIR}/resources/images/icons/oxygen/hicolor Resources/icons/hicolor)
	bundle_data(focuswriter ${CMAKE_SOURCE_DIR}/resources/sounds Resources/sounds)
	bundle_data(focuswriter ${CMAKE_SOURCE_DIR}/resources/symbols/symbols1510.dat Resources)
	bundle_data(focuswriter ${CMAKE_SOURCE_DIR}/resources/themes Resources/themes)
	bundle_translations(focuswriter "${translations_QM}")
elseif(WIN32)
	set(datadir ".")

	# Use Qt6 macro until CMake provides something
	# https://bugreports.qt.io/browse/QTBUG-87618
	set_target_properties(focuswriter PROPERTIES
		OUTPUT_NAME FocusWriter
		WIN32_EXECUTABLE TRUE
		QT_TARGET_VERSION "${PROJECT_VERSION}"
		QT_TARGET_COMPANY_NAME "Graeme Gott"
		QT_TARGET_DESCRIPTION "Fullscreen word processor"
		QT_TARGET_COPYRIGHT "\\xA9 ${project_copyright}"
		QT_TARGET_PRODUCT_NAME "FocusWriter"
		QT_TARGET_RC_ICONS ${CMAKE_SOURCE_DIR}/resources/windows/focuswriter.ico
	)
	_qt_internal_generate_win32_rc_file(focuswriter)
else()
	file(RELATIVE_PATH datadir ${CMAKE_INSTALL_FULL_BINDIR} ${CMAKE_INSTALL_FULL_DATADIR}/focuswriter)

	target_sources(focuswriter PRIVATE resources/images/icons/icons.qrc)

	install(TARGETS focuswriter RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
	install(FILES ${translations_QM} DESTINATION ${CMAKE_INSTALL_DATADIR}/focuswriter/translations)
	install(DIRECTORY resources/images/icons/hicolor DESTINATION ${CMAKE_INSTALL_DATADIR}/icons)
	install(DIRECTORY resources/images/icons/oxygen/hicolor DESTINATION ${CMAKE_INSTALL_DATADIR}/focuswriter/icons)
	install(DIRECTORY resources/sounds DESTINATION ${CMAKE_INSTALL_DATADIR}/focuswriter)
	install(DIRECTORY resources/themes DESTINATION ${CMAKE_INSTALL_DATADIR}/focuswriter)
	install(FILES resources/symbols/symbols1510.dat DESTINATION ${CMAKE_INSTALL_DATADIR}/focuswriter)
	install(FILES resources/unix/focuswriter.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1 COMPONENT doc)
	install(FILES resources/unix/focuswriter.appdata.xml DESTINATION ${CMAKE_INSTALL_DATADIR}/metainfo)
	install(FILES resources/unix/focuswriter.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
endif()

set_property(SOURCE src/main.cpp APPEND PROPERTY COMPILE_DEFINITIONS FOCUSWRITER_DATADIR="${datadir}")

=== debian/changelog ===
focuswriter (1.8.6-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:53:21 +1100

focuswriter (1.8.6-1build1) noble; urgency=medium

  * No-change rebuild against libqt6core6t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 12 Mar 2024 01:51:58 +0000

focuswriter (1.8.6-1) unstable; urgency=low

  * New upstream release

 -- Graeme Gott <graeme@gottcode.org>  Tue, 16 Jan 2024 19:24:15 +0000

=== debian/control ===
Source: focuswriter
Section: editors
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Barak A. Pearlmutter <bap@debian.org>
Uploaders: Graeme Gott <graeme@gottcode.org>
Build-Depends: debhelper-compat (= 13),
  cmake,
  mesa-common-dev,
  qt6-base-dev,
  qt6-tools-dev,
  qt6-tools-dev-tools,
  qt6-l10n-tools,
  qt6-multimedia-dev,
  libhunspell-dev,
  pkg-config,
  zlib1g-dev
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://gottcode.org/focuswriter/
Vcs-Git: https://salsa.debian.org/debian/focuswriter.git
Vcs-Browser: https://salsa.debian.org/debian/focuswriter

Package: focuswriter
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: hunspell-dictionary, myspell-dictionary
Description: Fullscreen distraction-free writing program
 Focuswriter is a fullscreen writing program designed to be
 distraction free.  You can customize your environment by changing the
 font, colors, and background image to add ambiance.  FocusWriter
 features an on-the-fly updating wordcount, optional auto-save,
 optional daily goals, and toolbars that hide away to allow you to
 focus more clearly.  Additionally, when you open the program your
 current work in progress will automatically load and position you at
 the end of your document, so that you can immediately jump back in.

## focuswriter 1.8.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 cmake_minimum_required(VERSION 3.16)
 
 # Configure project
-project(focuswriter VERSION 1.8.6 LANGUAGES CXX)
+project(focuswriter VERSION 1.8.7 LANGUAGES CXX)
 
 set(project_copyright "2008-2024 Graeme Gott")
 
@@ -28,25 +28,15 @@
 	QT_NO_KEYWORDS
 	$<$<CONFIG:DEBUG>:QT_STRICT_ITERATORS>
 	$<$<CONFIG:DEBUG>:QT_NO_NARROWING_CONVERSIONS_IN_CONNECT>
-	$<$<CONFIG:DEBUG>:QT_DISABLE_DEPRECATED_BEFORE=0x060600>
+	$<$<CONFIG:DEBUG>:QT_DISABLE_DEPRECATED_BEFORE=0x060700>
 )
 
 # Version number
 include(cmake/AddVersionCompileDefinition.cmake)
 add_version_compile_definition(src/application.cpp VERSIONSTR)
 
-# Create translations
-file(GLOB translations_SRCS translations/*.ts)
-qt6_add_translation(translations_QM ${translations_SRCS})
-
-add_custom_target(update_translations
-	COMMAND Qt6::lupdate -no-obsolete -locations none src -ts ${translations_SRCS}
-	WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
-	VERBATIM
-)
-
 # Create program
-qt6_add_executable(focuswriter
+qt_add_executable(focuswriter
 	src/action_manager.cpp
 	src/alert.cpp
 	src/alert_layer.cpp
@@ -132,6 +122,14 @@
 	ZLIB::ZLIB
 )
 
+# Create translations
+file(GLOB translations_SRCS translations/*.ts)
+qt_add_translations(focuswriter
+	TS_FILES ${translations_SRCS}
+	QM_FILES_OUTPUT_VARIABLE translations_QM
+	LUPDATE_OPTIONS -no-obsolete -locations none
+)
+
 # Add spellchecking support
 if(APPLE)
 	target_sources(focuswriter PRIVATE

=== debian/changelog ===
focuswriter (1.8.7-1~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 08 May 2024 20:24:27 -0700

focuswriter (1.8.7-1) unstable; urgency=medium

  * New upstream release
  * Bump policy version
  * Switch build dependency from pkg-config to pkgconf

 -- Barak A. Pearlmutter <bap@debian.org>  Fri, 03 May 2024 00:03:07 +0100

## focuswriter 1.8.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 cmake_minimum_required(VERSION 3.16)
 
 # Configure project
-project(focuswriter VERSION 1.8.7 LANGUAGES CXX)
+project(focuswriter VERSION 1.8.8 LANGUAGES CXX)
 
 set(project_copyright "2008-2024 Graeme Gott")
 
@@ -157,6 +157,12 @@
 		src/3rdparty/hunspell/replist.cxx
 		src/3rdparty/hunspell/suggestmgr.cxx
 	)
+
+	if (Qt6_VERSION VERSION_GREATER_EQUAL 6.5)
+		target_compile_definitions(focuswriter PRIVATE RTFCLIPBOARD)
+
+		target_sources(focuswriter PRIVATE src/fileformats/clipboard_windows.cpp)
+	endif()
 else()
 	find_package(PkgConfig REQUIRED)
 	pkg_check_modules(Hunspell REQUIRED IMPORTED_TARGET hunspell)

=== debian/changelog ===
focuswriter (1.8.8-1~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 27 Jul 2024 11:29:36 -0700

focuswriter (1.8.8-1) unstable; urgency=medium

  * New upstream release

 -- Graeme Gott <graeme@gottcode.org>  Tue, 21 May 2024 10:15:14 +0000

=== debian/control ===
--- 
+++ 
@@ -1,21 +1,21 @@
 Source: focuswriter
 Section: editors
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+Maintainer: Steven Pusser <stevep@mxlinux.org>
 XSBC-Original-Maintainer: Barak A. Pearlmutter <bap@debian.org>
 Uploaders: Graeme Gott <graeme@gottcode.org>
-Build-Depends: debhelper-compat (= 13),
-  cmake,
-  mesa-common-dev,
-  qt6-base-dev,
-  qt6-tools-dev,
-  qt6-tools-dev-tools,
-  qt6-l10n-tools,
-  qt6-multimedia-dev,
-  libhunspell-dev,
-  pkg-config,
-  zlib1g-dev
-Standards-Version: 4.6.2
+Build-Depends: cmake,
+               debhelper-compat (= 13),
+               libhunspell-dev,
+               mesa-common-dev,
+               pkgconf,
+               qt6-base-dev,
+               qt6-l10n-tools,
+               qt6-multimedia-dev,
+               qt6-tools-dev,
+               qt6-tools-dev-tools,
+               zlib1g-dev
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://gottcode.org/focuswriter/
 Vcs-Git: https://salsa.debian.org/debian/focuswriter.git

## focuswriter 1.8.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,11 @@
-# SPDX-FileCopyrightText: 2021-2023 Graeme Gott <graeme@gottcode.org>
+# SPDX-FileCopyrightText: 2021-2024 Graeme Gott <graeme@gottcode.org>
 #
 # SPDX-License-Identifier: GPL-3.0-or-later
 
 cmake_minimum_required(VERSION 3.16)
 
 # Configure project
-project(focuswriter VERSION 1.8.8 LANGUAGES CXX)
+project(focuswriter VERSION 1.8.9 LANGUAGES CXX)
 
 set(project_copyright "2008-2024 Graeme Gott")

=== debian/changelog ===
focuswriter (1.8.9-1) unstable; urgency=medium

  * New upstream release

 -- Graeme Gott <graeme@gottcode.org>  Fri, 11 Oct 2024 19:30:51 +0000

## focuswriter 1.8.10

=== debian/changelog ===
focuswriter (1.8.10-1) unstable; urgency=medium

  * New upstream release

 -- Graeme Gott <graeme@gottcode.org>  Fri, 14 Feb 2025 18:24:42 +0000

=== debian/control ===
--- 
+++ 
@@ -1,20 +1,20 @@
 Source: focuswriter
 Section: editors
 Priority: optional
-Maintainer: Steven Pusser <stevep@mxlinux.org>
-XSBC-Original-Maintainer: Barak A. Pearlmutter <bap@debian.org>
+Maintainer: Barak A. Pearlmutter <bap@debian.org>
 Uploaders: Graeme Gott <graeme@gottcode.org>
-Build-Depends: cmake,
-               debhelper-compat (= 13),
-               libhunspell-dev,
-               mesa-common-dev,
-               pkgconf,
-               qt6-base-dev,
-               qt6-l10n-tools,
-               qt6-multimedia-dev,
-               qt6-tools-dev,
-               qt6-tools-dev-tools,
-               zlib1g-dev
+Build-Depends: debhelper-compat (= 13),
+  cmake,
+  gettext,
+  mesa-common-dev,
+  qt6-base-dev,
+  qt6-tools-dev,
+  qt6-tools-dev-tools,
+  qt6-l10n-tools,
+  qt6-multimedia-dev,
+  libhunspell-dev,
+  pkgconf,
+  zlib1g-dev
 Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://gottcode.org/focuswriter/

## focuswriter 1.8.11

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,13 +1,13 @@
-# SPDX-FileCopyrightText: 2021-2024 Graeme Gott <graeme@gottcode.org>
+# SPDX-FileCopyrightText: 2021-2025 Graeme Gott <graeme@gottcode.org>
 #
 # SPDX-License-Identifier: GPL-3.0-or-later
 
 cmake_minimum_required(VERSION 3.16)
 
 # Configure project
-project(focuswriter VERSION 1.8.9 LANGUAGES CXX)
-
-set(project_copyright "2008-2024 Graeme Gott")
+project(focuswriter VERSION 1.8.11 LANGUAGES CXX)
+
+set(project_copyright "2008-2025 Graeme Gott")
 
 set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
@@ -28,7 +28,7 @@
 	QT_NO_KEYWORDS
 	$<$<CONFIG:DEBUG>:QT_STRICT_ITERATORS>
 	$<$<CONFIG:DEBUG>:QT_NO_NARROWING_CONVERSIONS_IN_CONNECT>
-	$<$<CONFIG:DEBUG>:QT_DISABLE_DEPRECATED_BEFORE=0x060700>
+	$<$<CONFIG:DEBUG>:QT_DISABLE_DEPRECATED_BEFORE=0x060800>
 )
 
 # Version number
@@ -37,6 +37,72 @@
 
 # Create program
 qt_add_executable(focuswriter
+	# Headers
+	src/action_manager.h
+	src/alert.h
+	src/alert_layer.h
+	src/application.h
+	src/block_stats.h
+	src/color_button.h
+	src/deltas.h
+	src/daily_progress.h
+	src/daily_progress_dialog.h
+	src/daily_progress_label.h
+	src/document.h
+	src/document_cache.h
+	src/document_watcher.h
+	src/document_writer.h
+	src/find_dialog.h
+	src/gzip.h
+	src/image_button.h
+	src/load_screen.h
+	src/locale_dialog.h
+	src/paths.h
+	src/preferences.h
+	src/preferences_dialog.h
+	src/scene_list.h
+	src/scene_model.h
+	src/session.h
+	src/session_manager.h
+	src/shortcut_edit.h
+	src/smart_quotes.h
+	src/sound.h
+	src/stack.h
+	src/stats.h
+	src/symbols_dialog.h
+	src/symbols_model.h
+	src/text_codec.h
+	src/theme.h
+	src/theme_dialog.h
+	src/theme_manager.h
+	src/theme_renderer.h
+	src/timer.h
+	src/timer_display.h
+	src/timer_manager.h
+	src/utils.h
+	src/window.h
+	src/fileformats/docx_reader.h
+	src/fileformats/docx_writer.h
+	src/fileformats/format_manager.h
+	src/fileformats/html_writer.h
+	src/fileformats/odt_reader.h
+	src/fileformats/odt_writer.h
+	src/fileformats/rtf_reader.h
+	src/fileformats/rtf_tokenizer.h
+	src/fileformats/rtf_writer.h
+	src/fileformats/txt_reader.h
+	src/spelling/abstract_dictionary.h
+	src/spelling/abstract_dictionary_provider.h
+	src/spelling/dictionary_dialog.h
+	src/spelling/dictionary_manager.h
+	src/spelling/dictionary_ref.h
+	src/spelling/highlighter.h
+	src/spelling/spell_checker.h
+	src/3rdparty/qtsingleapplication/qtsingleapplication.h
+	src/3rdparty/qtsingleapplication/qtlocalpeer.h
+	src/3rdparty/qtzip/qtzipreader.h
+	src/3rdparty/qtzip/qtzipwriter.h
+	# Sources
 	src/action_manager.cpp
 	src/alert.cpp
 	src/alert_layer.cpp
@@ -98,6 +164,7 @@
 	src/3rdparty/qtsingleapplication/qtsingleapplication.cpp
 	src/3rdparty/qtsingleapplication/qtlocalpeer.cpp
 	src/3rdparty/qtzip/qtzip.cpp
+	# Resources
 	resources/images/images.qrc
 	${translations_QM}
 )
@@ -133,6 +200,7 @@
 # Add spellchecking support
 if(APPLE)
 	target_sources(focuswriter PRIVATE
+		src/spelling/dictionary_provider_nsspellchecker.h
 		src/spelling/dictionary_provider_nsspellchecker.mm
 	)
 
@@ -144,7 +212,9 @@
 	target_include_directories(focuswriter PRIVATE src/3rdparty/hunspell)
 
 	target_sources(focuswriter PRIVATE
+		src/spelling/dictionary_provider_hunspell.h
 		src/spelling/dictionary_provider_hunspell.cpp
+		src/spelling/dictionary_provider_voikko.h
 		src/spelling/dictionary_provider_voikko.cpp
 		src/3rdparty/hunspell/affentry.cxx
 		src/3rdparty/hunspell/affixmgr.cxx
@@ -161,14 +231,19 @@
 	if (Qt6_VERSION VERSION_GREATER_EQUAL 6.5)
 		target_compile_definitions(focuswriter PRIVATE RTFCLIPBOARD)
 
-		target_sources(focuswriter PRIVATE src/fileformats/clipboard_windows.cpp)
+		target_sources(focuswriter PRIVATE
+			src/fileformats/clipboard_windows.h
+			src/fileformats/clipboard_windows.cpp
+		)
 	endif()
 else()
 	find_package(PkgConfig REQUIRED)
 	pkg_check_modules(Hunspell REQUIRED IMPORTED_TARGET hunspell)
 
 	target_sources(focuswriter PRIVATE
+		src/spelling/dictionary_provider_hunspell.h
 		src/spelling/dictionary_provider_hunspell.cpp
+		src/spelling/dictionary_provider_voikko.h
 		src/spelling/dictionary_provider_voikko.cpp
 	)
 
@@ -210,7 +285,7 @@
 	bundle_data(focuswriter ${CMAKE_SOURCE_DIR}/resources/mac/focuswriter.icns Resources)
 	bundle_data(focuswriter ${CMAKE_SOURCE_DIR}/resources/images/icons/oxygen/hicolor Resources/icons/hicolor)
 	bundle_data(focuswriter ${CMAKE_SOURCE_DIR}/resources/sounds Resources/sounds)
-	bundle_data(focuswriter ${CMAKE_SOURCE_DIR}/resources/symbols/symbols1510.dat Resources)
+	bundle_data(focuswriter ${CMAKE_SOURCE_DIR}/resources/symbols/symbols1600.dat Resources)
 	bundle_data(focuswriter ${CMAKE_SOURCE_DIR}/resources/themes Resources/themes)
 	bundle_translations(focuswriter "${translations_QM}")
 elseif(WIN32)
@@ -240,10 +315,11 @@
 	install(DIRECTORY resources/images/icons/oxygen/hicolor DESTINATION ${CMAKE_INSTALL_DATADIR}/focuswriter/icons)
 	install(DIRECTORY resources/sounds DESTINATION ${CMAKE_INSTALL_DATADIR}/focuswriter)
 	install(DIRECTORY resources/themes DESTINATION ${CMAKE_INSTALL_DATADIR}/focuswriter)
-	install(FILES resources/symbols/symbols1510.dat DESTINATION ${CMAKE_INSTALL_DATADIR}/focuswriter)
+	install(FILES resources/symbols/symbols1600.dat DESTINATION ${CMAKE_INSTALL_DATADIR}/focuswriter)
 	install(FILES resources/unix/focuswriter.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1 COMPONENT doc)
-	install(FILES resources/unix/focuswriter.appdata.xml DESTINATION ${CMAKE_INSTALL_DATADIR}/metainfo)
-	install(FILES resources/unix/focuswriter.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
+
+	include(cmake/TranslateMetainfo.cmake)
+	process_and_install_metainfo(PO_DIR ${CMAKE_SOURCE_DIR}/resources/unix/po)
 endif()
 
 set_property(SOURCE src/main.cpp APPEND PROPERTY COMPILE_DEFINITIONS FOCUSWRITER_DATADIR="${datadir}")

=== debian/changelog ===
focuswriter (1.8.11-1) unstable; urgency=medium

  [ Graeme Gott ]
  * New upstream release

  [ Barak A. Pearlmutter ]
  * Update standards version to 4.7.2, no changes needed
  * Trivially update debian/copyright

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 10 Mar 2025 14:02:33 +0000

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
   libhunspell-dev,
   pkgconf,
   zlib1g-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://gottcode.org/focuswriter/
 Vcs-Git: https://salsa.debian.org/debian/focuswriter.git

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@

## focuswriter 1.8.12

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 cmake_minimum_required(VERSION 3.16)
 
 # Configure project
-project(focuswriter VERSION 1.8.11 LANGUAGES CXX)
+project(focuswriter VERSION 1.8.12 LANGUAGES CXX)
 
 set(project_copyright "2008-2025 Graeme Gott")
 
@@ -28,7 +28,7 @@
 	QT_NO_KEYWORDS
 	$<$<CONFIG:DEBUG>:QT_STRICT_ITERATORS>
 	$<$<CONFIG:DEBUG>:QT_NO_NARROWING_CONVERSIONS_IN_CONNECT>
-	$<$<CONFIG:DEBUG>:QT_DISABLE_DEPRECATED_BEFORE=0x060800>
+	$<$<CONFIG:DEBUG>:QT_DISABLE_DEPRECATED_BEFORE=0x060900>
 )
 
 # Version number

=== debian/changelog ===
focuswriter (1.8.12-1) unstable; urgency=medium

  [ Graeme Gott ]
  * New upstream release

  [ Barak A. Pearlmutter ]
  * debian/copyright: use spaces rather than tabs to start continuation lines.

 -- Barak A. Pearlmutter <bap@debian.org>  Sun, 18 May 2025 15:22:57 +0100

## focuswriter 1.8.13

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 cmake_minimum_required(VERSION 3.16)
 
 # Configure project
-project(focuswriter VERSION 1.8.12 LANGUAGES CXX)
+project(focuswriter VERSION 1.8.13 LANGUAGES CXX)
 
 set(project_copyright "2008-2025 Graeme Gott")

=== resources/symbols/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2021 Graeme Gott <graeme@gottcode.org>
#
# SPDX-License-Identifier: GPL-3.0-or-later

qt6_add_executable(generate main.cpp)

target_link_libraries(generate PRIVATE
	Qt6::Core
	Qt6::Network
)

add_custom_target(symbols
	COMMAND generate
	DEPENDS main.cpp
	WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)

=== debian/changelog ===
focuswriter (1.8.13-1~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sun, 07 Sep 2025 13:38:30 -0700

focuswriter (1.8.13-1) unstable; urgency=medium

  [ Graeme Gott ]
  * New upstream release

  [ Barak A. Pearlmutter ]
  * Rules-requires-root now defaults to no

 -- Barak A. Pearlmutter <bap@debian.org>  Fri, 22 Aug 2025 12:26:09 +0100

=== debian/control ===
--- 
+++ 
@@ -1,22 +1,22 @@
 Source: focuswriter
 Section: editors
 Priority: optional
-Maintainer: Barak A. Pearlmutter <bap@debian.org>
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+XSBC-Original-Maintainer: Barak A. Pearlmutter <bap@debian.org>
 Uploaders: Graeme Gott <graeme@gottcode.org>
-Build-Depends: debhelper-compat (= 13),
-  cmake,
-  gettext,
-  mesa-common-dev,
-  qt6-base-dev,
-  qt6-tools-dev,
-  qt6-tools-dev-tools,
-  qt6-l10n-tools,
-  qt6-multimedia-dev,
-  libhunspell-dev,
-  pkgconf,
-  zlib1g-dev
+Build-Depends: cmake,
+               debhelper-compat (= 13),
+               gettext,
+               libhunspell-dev,
+               mesa-common-dev,
+               pkgconf,
+               qt6-base-dev,
+               qt6-l10n-tools,
+               qt6-multimedia-dev,
+               qt6-tools-dev,
+               qt6-tools-dev-tools,
+               zlib1g-dev
 Standards-Version: 4.7.2
-Rules-Requires-Root: no
 Homepage: https://gottcode.org/focuswriter/
 Vcs-Git: https://salsa.debian.org/debian/focuswriter.git
 Vcs-Browser: https://salsa.debian.org/debian/focuswriter

=== debian/rules ===
--- 
+++ 
@@ -6,3 +6,8 @@
 
 %:
 	dh $@
+
+# No dbgsym packages:
+override_dh_strip:
+	@echo "NO--THANKS ANYWAY--but not building dbgsym packages for MX Linux"
+	dh_strip --no-automatic-dbgsym

## focuswriter 1.9.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,13 +1,13 @@
-# SPDX-FileCopyrightText: 2021-2025 Graeme Gott <graeme@gottcode.org>
+# SPDX-FileCopyrightText: 2021 Graeme Gott <graeme@gottcode.org>
 #
 # SPDX-License-Identifier: GPL-3.0-or-later
 
 cmake_minimum_required(VERSION 3.16)
 
 # Configure project
-project(focuswriter VERSION 1.8.13 LANGUAGES CXX)
-
-set(project_copyright "2008-2025 Graeme Gott")
+project(focuswriter VERSION 1.9.0 LANGUAGES CXX)
+
+set(project_copyright "2008-2026 Graeme Gott")
 
 set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
@@ -28,12 +28,15 @@
 	QT_NO_KEYWORDS
 	$<$<CONFIG:DEBUG>:QT_STRICT_ITERATORS>
 	$<$<CONFIG:DEBUG>:QT_NO_NARROWING_CONVERSIONS_IN_CONNECT>
-	$<$<CONFIG:DEBUG>:QT_DISABLE_DEPRECATED_BEFORE=0x060900>
+	$<$<CONFIG:DEBUG>:QT_DISABLE_DEPRECATED_BEFORE=0x061000>
+)
+add_compile_options(
+	$<$<CONFIG:DEBUG>:-Wshadow>
 )
 
 # Version number
 include(cmake/AddVersionCompileDefinition.cmake)
-add_version_compile_definition(src/application.cpp VERSIONSTR)
+add_version_compile_definition(src/main.cpp VERSIONSTR)
 
 # Create program
 qt_add_executable(focuswriter
@@ -41,7 +44,6 @@
 	src/action_manager.h
 	src/alert.h
 	src/alert_layer.h
-	src/application.h
 	src/block_stats.h
 	src/color_button.h
 	src/deltas.h
@@ -98,15 +100,12 @@
 	src/spelling/dictionary_ref.h
 	src/spelling/highlighter.h
 	src/spelling/spell_checker.h
-	src/3rdparty/qtsingleapplication/qtsingleapplication.h
-	src/3rdparty/qtsingleapplication/qtlocalpeer.h
 	src/3rdparty/qtzip/qtzipreader.h
 	src/3rdparty/qtzip/qtzipwriter.h
 	# Sources
 	src/action_manager.cpp
 	src/alert.cpp
 	src/alert_layer.cpp
-	src/application.cpp
 	src/block_stats.cpp
 	src/color_button.cpp
 	src/deltas.cpp
@@ -161,8 +160,6 @@
 	src/spelling/dictionary_manager.cpp
 	src/spelling/highlighter.cpp
 	src/spelling/spell_checker.cpp
-	src/3rdparty/qtsingleapplication/qtsingleapplication.cpp
-	src/3rdparty/qtsingleapplication/qtlocalpeer.cpp
 	src/3rdparty/qtzip/qtzip.cpp
 	# Resources
 	resources/images/images.qrc
@@ -173,7 +170,6 @@
 	src
 	src/fileformats
 	src/spelling
-	src/3rdparty/qtsingleapplication
 	src/3rdparty/qtzip
 )
 
@@ -250,6 +246,23 @@
 	target_link_libraries(focuswriter PRIVATE PkgConfig::Hunspell)
 endif()
 
+# Make single instance
+find_package(KDSingleApplication-qt6)
+if(TARGET KDAB::kdsingleapplication)
+	target_link_libraries(focuswriter PRIVATE KDAB::kdsingleapplication)
+else()
+	message(STATUS "Using 3rdparty KDSingleApplication")
+
+	target_compile_definitions(focuswriter PRIVATE KDSINGLEAPPLICATION_STATIC_BUILD)
+
+	target_include_directories(focuswriter PRIVATE src/3rdparty/kdsingleapplication)
+
+	target_sources(focuswriter PRIVATE
+		src/3rdparty/kdsingleapplication/kdsingleapplication.cpp
+		src/3rdparty/kdsingleapplication/kdsingleapplication_localsocket.cpp
+	)
+endif()
+
 # Optimize build
 option(ENABLE_LINK_TIME_OPTIMIZATION "Enable link time optimization" OFF)
 if(ENABLE_LINK_TIME_OPTIMIZATION)
@@ -285,7 +298,7 @@
 	bundle_data(focuswriter ${CMAKE_SOURCE_DIR}/resources/mac/focuswriter.icns Resources)
 	bundle_data(focuswriter ${CMAKE_SOURCE_DIR}/resources/images/icons/oxygen/hicolor Resources/icons/hicolor)
 	bundle_data(focuswriter ${CMAKE_SOURCE_DIR}/resources/sounds Resources/sounds)
-	bundle_data(focuswriter ${CMAKE_SOURCE_DIR}/resources/symbols/symbols1600.dat Resources)
+	bundle_data(focuswriter ${CMAKE_SOURCE_DIR}/resources/symbols/symbols1700.dat Resources)
 	bundle_data(focuswriter ${CMAKE_SOURCE_DIR}/resources/themes Resources/themes)
 	bundle_translations(focuswriter "${translations_QM}")
 elseif(WIN32)
@@ -315,7 +328,7 @@
 	install(DIRECTORY resources/images/icons/oxygen/hicolor DESTINATION ${CMAKE_INSTALL_DATADIR}/focuswriter/icons)
 	install(DIRECTORY resources/sounds DESTINATION ${CMAKE_INSTALL_DATADIR}/focuswriter)
 	install(DIRECTORY resources/themes DESTINATION ${CMAKE_INSTALL_DATADIR}/focuswriter)
-	install(FILES resources/symbols/symbols1600.dat DESTINATION ${CMAKE_INSTALL_DATADIR}/focuswriter)
+	install(FILES resources/symbols/symbols1700.dat DESTINATION ${CMAKE_INSTALL_DATADIR}/focuswriter)
 	install(FILES resources/unix/focuswriter.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1 COMPONENT doc)
 
 	include(cmake/TranslateMetainfo.cmake)

=== debian/changelog ===
focuswriter (1.9.0-1) unstable; urgency=medium
  [ Graeme Gott ]

  * New upstream release
  * Add dependency on libkdsingleapplcation-qt6

  [ Barak A. Pearlmutter ]
  * Update debian/watch file to version 5
  * Bump policy

 -- Barak A. Pearlmutter <bap@debian.org>  Sun, 14 Dec 2025 15:13:13 +0000

=== debian/control ===
--- 
+++ 
@@ -1,22 +1,21 @@
 Source: focuswriter
 Section: editors
-Priority: optional
-Maintainer: Steven Pusser <stevep@mxlinux.org>
-XSBC-Original-Maintainer: Barak A. Pearlmutter <bap@debian.org>
+Maintainer: Barak A. Pearlmutter <bap@debian.org>
 Uploaders: Graeme Gott <graeme@gottcode.org>
-Build-Depends: cmake,
-               debhelper-compat (= 13),
-               gettext,
-               libhunspell-dev,
-               mesa-common-dev,
-               pkgconf,
-               qt6-base-dev,
-               qt6-l10n-tools,
-               qt6-multimedia-dev,
-               qt6-tools-dev,
-               qt6-tools-dev-tools,
-               zlib1g-dev
-Standards-Version: 4.7.2
+Build-Depends: debhelper-compat (= 13),
+  cmake,
+  gettext,
+  mesa-common-dev,
+  qt6-base-dev,
+  qt6-tools-dev,
+  qt6-tools-dev-tools,
+  qt6-l10n-tools,
+  qt6-multimedia-dev,
+  libhunspell-dev,
+  libkdsingleapplication-qt6-dev,
+  pkgconf,
+  zlib1g-dev
+Standards-Version: 4.7.3
 Homepage: https://gottcode.org/focuswriter/
 Vcs-Git: https://salsa.debian.org/debian/focuswriter.git
 Vcs-Browser: https://salsa.debian.org/debian/focuswriter

=== debian/watch ===
Version: 5
Template: GitHub
Owner: gottcode
Project: @PACKAGE@
